#!/bin/csh -f

#
# Default/setup variables (generated by Install)
#
__default-setup-var__



#
# Sanity check, make sure script and executable are same version
#
set runMajorVer="`/bin/cat $CHALICEROOT/.VERSION`"
if ( $majorVer != $runMajorVer ) then
	echo "Sorry, you are trying to run the cleanChalice utility for Chalice $runMajorVer with a"
	echo "script ($0) created to work with Chalice $majorVer."
	exit 1
endif


#
# Make sure we can run on this system
#
set osType=`/bin/uname -s | /bin/sed 's/64$//'`
set osVer=`/bin/uname -r`

if ( ($osType != "IRIX" && $osType != "Linux") || \
	 ($osType == "IRIX" && $osVer !~ 6.[2345]) ) then
	echo "The cleanChalice utility for Chalice $majorVer doesn't run on $osType $osVer."
	echo "It only runs on IRIX 6.X and Linux."
	exit 1
endif


#
# Other variables added by user (generated by Install)
#
__user-added-vars__


killall chalice
killall chaliceWork
killall chal

$CHALICEROOT/bin/chaliceShared $argv
