/******************************************************************************
*								
*	(C) Copyright 1992 GW Hannaway & Associates, Inc.
*
*	This program is an unpublished work fully protected by the United
*	States Copyright Laws and is considered a trade secret belonging to 
*	GW Hannaway & Associates, Inc.
*
******************************************************************************/
#ifndef ERROR_PLUS_PLUS_H
#define ERROR_PLUS_PLUS_H
#include <error/error.h>

//#include <errorpp/errorpp.h>

class Error {
	int	occurred;

public:
	Error() { occurred = 0; }

	void	V(
#ifdef ERROR_LOCATION_LOGGING
			const char	 *file,
			int			  line,
#endif /* ERROR_LOCATION_LOGGING */
			int			  strength,
			int			(*display)( int, const char * ),
			ErrorType	  type,
			const char	 *fmt,
			... );

	int		I(
#ifdef ERROR_LOCATION_LOGGING
			const char	 *file,
			int			  line,
#endif /* ERROR_LOCATION_LOGGING */
			int			  strength,
			int			(*display)( int, const char * ),
			int			  retval,
			ErrorType	  type,
			const char	 *fmt,
			... );

	void	*P(
#ifdef ERROR_LOCATION_LOGGING
			const char	 *file,
			int			  line,
#endif /* ERROR_LOCATION_LOGGING */
			int			  strength,
			int			(*display)( int, const char * ),
			void		 *retval,
			ErrorType	  type,
			const char	 *fmt,
			... );

	int		D(
#ifdef ERROR_LOCATION_LOGGING
			const char	 *file,
			int			  line,
#endif /* ERROR_LOCATION_LOGGING */
			int			  strength,
			int			(*display)( int, const char * ),
			ErrorType	  type,
			const char	 *fmt,
			... );

	int			 Pop()		{ return errorPop( ); }
	void		 Clear()	{ errorClear( ); }
	int			 Errno()	{ return errorErrno( ); }
	ErrorType	 Type()		{ return errorType( ); }
	const char	*String( int *length = 0 ) { return errorString( length ); }
	void		 Top()		{ errorTop( ); }
	void		 Bottom()	{ errorBottom( ); }
	int			 Up()		{ return errorUp( ); }
	int			 Down()		{ return errorDown( ); }
	int			 Occurred()	{ return occurred && errorOccurred( ); }
	ErrorHolder	 Pull()		{ return errorPull( ); }
	void		 Push( ErrorHolder hold ) { errorPush( hold ); occurred = 1; }
};

#endif /* ERROR_PLUS_PLUS_H */
