//
// PROPRIETARY INFORMATION.  This software is proprietary to
// Silicon Grail Corporation, and is not to be reproduced,
// transmitted, or disclosed in any way without written permission.
//
//  Produced by:
//  Silicon Grail Corporation
//  710 N. Seward
//  Hollywood, CA
//  USA 90038
//  213-871-9100
//
// NAME: ImFmt.h
//
// COMMENTS:
//	
/* $Id: ImFmt.h,v 1.1.1.1 1999/10/06 21:12:44 build Exp $ */

#ifndef IM_FMT_H
#define IM_FMT_H

#include "ImFile.h"

class ImCopy;

class ImFmt : public ImFile {
public:
	ImFmt( ) { }
	ImFmt( const char * const fname, FILE *file, const Uint32 perm ) :
		ImFile( fname, file, perm ) { }
	ImFmt(
			const char			*fname,
			FILE				*file,
			const Uint32		 perm,
			const Uint			 numDims,		// number of dimensions
			const ImArray<Uint>	&dimBounds,		// bounds in each dimension
			const Uint			 numChannels,	// number of channels
			const ImArray<Uint>	&bitsPerChannel,// num of bits per channel
			const ImArray<Uint>	&significantBits,// num of significant channel
			const DataType		 channelType,	// data type
			const ColorSpace	 colorSpace,	// Color space
			const ArrayChannel	&channelMaps,	// channel lookup tables
			const Uint			 attributes		// image attributes
		) : ImFile( fname, file, perm, numDims, dimBounds, numChannels,
					bitsPerChannel, significantBits, channelType, colorSpace,
					channelMaps, attributes ) { }

	virtual			~ImFmt();

protected:
	//
	// See if we are read/writing all channels in order
	//
	ImBooln				 allChannels( const SubArea &area );

	//
	// See if we are changing the bit depth.
	//
	ImBooln				 stretchBits( const SubArea &area );

	//
	// Pick a copy class to do the data moving.
	//
	ImCopy				*selectCopier( const SubArea &area, ImBooln stretch );

}; /* end class ImFmt */

#endif /* IM_FMT_H */
