//
// PROPRIETARY INFORMATION.  This software is proprietary to
// Silicon Grail Corporation, and is not to be reproduced,
// transmitted, or disclosed in any way without written permission.
//
//  Produced by:
//  Silicon Grail Corporation
//  710 N. Seward
//  Hollywood, CA
//  USA 90038
//  213-871-9100
//
// NAME: ImFormats.h
//
// COMMENTS:
//	
/* $Id: ImFormats.h,v 1.1.1.1 1999/10/06 21:12:45 build Exp $ */

/***************/
/* ImFormats.h */
/***************/

#ifndef IM_FORMATS_H
#define IM_FORMATS_H

// it is important to list these objects in order
// of how easy it is to positively identify them
// as being a specific type -- eg. Tiff, Sun, 
// Alias Eclipse, Sgi, and Photoshop all are
// very easy to identify because they have
// "magic" numbers in their respective file
// headers whereas several values in the headers
// of the other file types have to be checked
// to see if they make sense.
// The reason for the imposed order is that
// the compiler will create the exemplar list
// in the reverse order of the following list so 
// that the easiest identifible files -- ie. Tiff,
// SoftI -- will be checked first. Other compilers
// -- Sun Solaris -- will use the object list
// in the Imakefile to determine the exemplar 
// list order so that list should be in the same order.

#ifndef IM_DSO

	#include "ImRaw.h"
	#include "ImYUV.h"
	#include "ImBmp.h"
	#include "ImAliasZ.h"
	#include "ImAlias.h"

	#ifdef WIN32
		#include "ImAVI.h"	
		#include "ImRll.h"
	#endif

	#include "ImWhip.h"
	
	#ifdef IM_PS
		#include "ImPs.h"
	#endif

	#include "ImJpeg.h"	
	#include "ImXwd.h"
	#include "ImWave.h"		
	#include "ImPict.h"
	#include "ImIff.h"		
	#include "ImTarga.h"
	#include "ImMaya.h"
	
	#ifndef WIN32
		#ifdef IIS_FMT
			#include "ImIis.h"
		#endif
		#ifdef IM_MOVIE
			#include "ImMovie.h"
		#endif
		
	#endif

	#include "ImPhoto.h"
	#include "ImQuantel.h"	
	#include "ImDpx.h"
	#include "ImFido.h"
	#include "ImSideFx.h"
	#include "ImSgi.h"
		
	#ifndef WIN32
		#include "ImAliasE.h"
	#endif
	
	#include "ImCdi.h"	
	#include "ImSun.h"		
	#include "ImSoftI.h"
	#include "ImZpic.h"
	#include "ImTiff.h"

	#include "ImFrp.h"
	#include "ImAccom.h"
	#ifndef WIN32
		#ifdef IMPRESSARIO
			#include "ImPSTiff.h"
		#endif
	#endif

#else

#include "ImFile.h"

#endif /* ! IM_DSO */

#ifdef IM_STATIC
void ImFilesForceLoad();
#endif

#endif /* IM_FORMATS_H */
