//
// PROPRIETARY INFORMATION.  This software is proprietary to
// Silicon Grail Corporation, and is not to be reproduced,
// transmitted, or disclosed in any way without written permission.
//
//  Produced by:
//  Silicon Grail Corporation
//  710 N. Seward
//  Hollywood, CA
//  USA 90038
//  213-871-9100
//
// NAME: ImList.h
//
// COMMENTS:
//	
/* $Id: ImList.h,v 1.1.1.1 1999/10/06 21:12:45 build Exp $ */

#ifndef IM_LIST_H
#define IM_LIST_H

template <class T> class ImList;

template <class T> 
class ImListItem {
public:
					 ImListItem( T *t, ImListItem *n, ImListItem *p ) : 
								data(t), next(n), prev(p) {}
					~ImListItem();

private:
	T				*data;
	ImListItem<T>	*next;
	ImListItem<T>	*prev;

	friend class	 ImList<T>;
};	/* end 	class ImListItem  */

template <class T> 
class ImList {
public:
					 ImList( );
					~ImList();

	ImBooln			 add( T *d, ImDirection dir );
	ImBooln			 remove( );

	T				*first( );
	T				*last( );
	T				*next( );
	T				*prev( );

	void			 moveFirst( );	// move current element to the beginning
	void			 moveLast( );	// move current element to the end
	const T			*data( ) const;

	Uint32			 size( ) { return count; }
private:
	void			 add(ImListItem<T>	*which,
						 ImListItem<T>	*where,
						 ImDirection	 dir );
	void			 remove( ImListItem<T> *where );

	ImListItem<T>	*head;
	ImListItem<T>	*tail;
	ImListItem<T>	*current;
	Uint32			 count;
};	/* end class List */

#endif
