//
// PROPRIETARY INFORMATION.  This software is proprietary to
// Silicon Grail Corporation, and is not to be reproduced,
// transmitted, or disclosed in any way without written permission.
//
//  Produced by:
//  Silicon Grail Corporation
//  710 N. Seward
//  Hollywood, CA
//  USA 90038
//  213-871-9100
//
// NAME: ImMatrix.h
//
// COMMENTS:
//	

#ifndef IM_MATRIX_H
#define IM_MATRIX_H

#include <math.h>
#include "ImDefs.h"
#include <ErrorPP/ErrorPP.h>

#define MATRIX_DIM	4
typedef float ImMatrixType;

typedef float MATRIX[MATRIX_DIM][MATRIX_DIM];

class ImMatrix {
public:
	enum			 ImAxis { X, Y, Z };

					 ImMatrix() { ident(); }
					 ImMatrix( const ImMatrix &m ) { copy( m ); }

	void			 transMat( const ImMatrixType tx, 
							   const ImMatrixType ty, 
							   const ImMatrixType tz = 0.0 );
	void			 scaleMat( const ImMatrixType sx, 
							   const ImMatrixType sy,
							   const ImMatrixType sz = 1.0 );
	void			 rotMat( const ImMatrixType degrees,
							 const ImAxis	axis );
	void			 transpose();
	void			 xform( Uint32 *x, Uint32 *y );
	void			 xform( Int16 *x, Int16 *y );
	void			 ixform( float *x, float *y );
	void			 xform( float *x, float *y );

private:
	void			 ident();
	void			 copy( const ImMatrix &m );
	void			 printMat( const char *mesg );
	ImMatrixType	 inverse( );

	MATRIX			 mat;
	MATRIX			 invmat;
	Error			 error;
};	/* end class ImMatrix */


#endif
