//
// PROPRIETARY INFORMATION.  This software is proprietary to
// Silicon Grail Corporation, and is not to be reproduced,
// transmitted, or disclosed in any way without written permission.
//
//  Produced by:
//  Silicon Grail Corporation
//  710 N. Seward
//  Hollywood, CA
//  USA 90038
//  213-871-9100
//
// NAME: ImTools.h
//
// COMMENTS:
//	
/* $Id: ImTools.h,v 1.1.1.1 1999/10/06 21:12:45 build Exp $ */

#ifndef	IM_TOOLS_H
#define	IM_TOOLS_H

#include <string.h>

template <class T>
inline T ImMin( T a, T b ) 
{
	return a < b ? a : b;
}

template <class T>
inline T ImMin( T a, T b, T c ) 
{
	return ImMin( a, ImMin( b, c ) );
}

template <class T>
inline T ImMax( T a, T b ) 
{
	return a > b ? a : b;
}

template <class T>
inline T ImMax( T a, T b, T c ) 
{
	return ImMax( a, ImMax( b, c ) );
}

template <class T>
inline T ImClamp(T in, T minv, T maxv)
{
	return in < minv ? minv : in > maxv ? maxv : in;
}

template <class T>
inline void ImSwap( T &a, T &b )
{
		T t;
		t = a;
		a = b;
		b = t;
}

inline char *ImStrdup(const char *s)
{
	char *n;

	if ( s ) {
		n = new char[strlen(s) + 1];
		if( NOTNULL(n) )
			strcpy(n, s);
		return n;
	} else
		return NULL;
}

inline Uint16 swapShort(const Uint16 in)
{
	// This method is used in RPCNDR.h
	return ( ( in & 0x00ff ) << 8 ) | ( ( in >> 8 ) & 0x00ff );
}

inline Uint32 swapLong(const Uint32 in)
{
	// This method is used in RPCNDR.h
	return	( ( in & 0x000000ff ) << 24 ) |
			( ( in & 0x0000ff00 ) <<  8 ) |
			( ( in & 0x00ff0000 ) >>  8 ) |
			( ( in & 0xff000000 ) >> 24 );
}

inline float swapFloat(const float in)
{
	float 			 t = in;
	Uint32		*swap = (Uint32*)&t, l;

	// This method is used in RPCNDR.h 
	l = (( ( *swap & 0x000000ff ) << 24 ) |
	    ( ( *swap & 0x0000ff00 ) <<  8 ) |
	    ( ( *swap & 0x00ff0000 ) >>  8 ) |
	    ( ( *swap & 0xff000000 ) >> 24 ));

	return *(float*)&l;
}

#endif /* IM_TOOLS_H */
