
#######################################
# Set up the compiler flags
#######################################

.SUFFIXES : so
CC = cl.exe

CFLAGS = /nologo /MD /O2 /TP /D "WIN32" /D "NDEBUG"

LINK = link.exe

LINK_OPTIONS = /nologo /RELEASE /OPT:NOREF /DLL /out:$@

LIBS = cpi.obj PI_Util.lib

#######################################
# Now build the various plugins
#######################################

OBJECTS = Tile.C \
	CircleRamp.C \
	Dither.C \
	Gaussian.C \
	Normalize.C \
	Solarize.C


LINK_ARGS = $(LINK_OPTIONS)

all : $(OBJECTS:.C=.so)

.C.so:
	$(CC) $(CFLAGS) /c $<
	$(LINK) $(LINK_OPTIONS) $*.obj $(LIBS)
	del $*.exp $*.lib

clean :
	erase $(OBJECTS:.C=.obj) $(OBJECTS:.C=.so)

erase :
	erase $(OBJECTS:.C=.obj) $(OBJECTS:.C=.so)

#######################################
# End of file: "MakefileTrailer.mak" 
#######################################


